<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Github Tracker</title>
    <script src="/vue.js"></script>
    <style>
        body {
            background: #fefefe;
        }
        pre {
            background: #222;
            color: #fff;
            padding: 8px;
        }
    </style>
</head>
<body style="padding: 0; margin: 0">
    <div style="width: 100%; padding: 0; margin: 0 auto; font-family: Arial, Helvetica, sans-serif" id="app">
        <h1 style="padding: 8px">Welcome to Github Tracker</h1>
        <div style="width: 100%; height: 100vh; display: flex;">
            <div style="width: 30%; background: dodgerblue; padding: 8px; color: #fff;">
                <h3>{{ message }}</h3>
                <p v-if="isFetching">Loading...</p>
                <div v-else style="max-height: 90vh; overflow-y: scroll">
                    <div style="padding: 8px" v-for="issue in ghissues.issues">
                        <a style="color: #fff; text-decoration: unset" href="#" v-on:click="selectIssue(issue)">
                            <span style="color: yellow">
                                #{{ issue.number }}
                            </span>
                            {{ issue.title }}
                        </a>
                    </div>
                </div>
            </div>

            <div style="width: 70%; max-height: 80vh; overflow-y: scroll; padding: 8px;">
                <h3>Issue #{{ selectedIssue.number }}</h3>
                <div style="padding: 8px" v-html="selectedIssue.bodyHtml"></div>
                <hr>
                
                <h4>Comments</h4>
                <ul v-show="showDetail">
                    <li style="list-style-type: none;" v-for="cmt in selectedIssue.comments">
                        <div style="display: flex; align-items: center;">
                            <img style="height: 36px; margin-right: 8px" :src="cmt.author.avatarUrl">
                            <a :href="cmt.author.url">{{ cmt.author.login }}</a>
                        </div>
                        <div v-html="cmt.bodyHtml"></div>
                        <hr>
                    </li>
                </ul>
            </div>
        </div>
    </div>

    <script>
        const app = new Vue({
            el: '#app',
            data: {
                message: 'facebook/react issues',
                ghissues: {
                    issues: []
                },
                isFetching: false,
                showDetail: false,
                selectedIssue: {
                    comments: []
                },
            },
            methods: {
                getGhTracker() {
                    this.isFetching = true
                    fetch('/api/ghtracker', {
                        method: 'GET'
                    })
                    .then(res => res.json())
                    .then(({ data }) => {
                        this.ghissues.issues = data.issues
                        console.log(data.issues)
                        this.isFetching = false
                    })
                    .catch(e => {
                        this.isFetching = false
                        console.error(e)
                    })
                },
                selectIssue(issue) {
                    this.showDetail = true
                    this.selectedIssue = issue
                }
            },
            mounted() {
                this.getGhTracker()
            }
        })
    </script>
</body>
</html>